#import <stdio.h>
#import <stdlib.h>
#import <string.h>
#import <fcntl.h>
#import <sys/stat.h>
#import <sys/types.h>
#import <inttypes.h>
#import <unistd.h>
#define __STDC_FORMAT_MACROS

#import <time.h>
#import <math.h>
#import <mach/mach.h>
#import <Cocoa/Cocoa.h>
#import <CoreFoundation/CFNumber.h>
#import <IOKit/IOKitLib.h>
#import <IOKit/IOCFPlugIn.h>
#import <IOKit/usb/IOUSBLib.h>

@interface Friio : NSObject {
	mach_port_t				masterPort;
    io_service_t			usbDeviceRef;
	io_service_t			usbInterfaceRef;
	IOUSBDeviceInterface	**dev;
	IOUSBInterfaceInterface	**interface;
	const char				*file_path;
	int						friio_type;
	int						find_type;
	
}

// レスポンス構造体
typedef struct{
	IOUSBInterfaceInterface	**interface;
	UInt8					buffer[327680];
	FILE					*fd;
} USBResponse;

typedef enum {
	FRIIO_ANY,
	FRIIO_WHITE,
	FRIIO_BLACK,
	FRIIO_TYPES_LEN,
} FriioType;
	
// インスタンスメソッド
- (int)open:(int)type;
- (int)_findDeviceInterface;
- (int)_setupInterface;
- (int)close;

- (int)_sendRequest:(UInt16)wValue withIndex:(UInt16)wIndex;
- (int)initStageA;
- (int)initStageB;
- (int)initStream;

@end
